<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    item: {
      type: Object,
      required: true,
    },
    isActive: {
      type: Boolean,
      required: true,
      default: false,
    },
    isMobile: {
      type: Boolean,
      required: true,
      default: false,
    },
    animationType: {
      type: String,
      required: true,
      default: 'fade-left',
    },
  },
});
</script>

<template>
  <section
    class="solutions-item"
    :class="{ 'solutions-item--inactive': !isActive }"
  >
    <SlpRow :class="{ 'solutions-item__mobile': isMobile }">
      <SlpColumn :cols="6" class="slp-pr-32 slp-pb-md-96 slp-pb-32">
        <SlpIcon
          v-if="item.icon"
          class="slp-mb-24 solutions-item__icon"
          :name="item.icon.name"
          :alt="item.icon.alt"
          :variant="item.icon.variant"
        />
        <SlpTypography class="slp-mb-16" tag="h3" variant="heading3-bold"
          >{{ item.title }}
        </SlpTypography>
        <SlpTypography tag="p" variant="body1"
          >{{ item.description }}
        </SlpTypography>
        <SlpButton
          v-if="!isMobile && item.link_url"
          class="slp-mt-32 learn-more"
          variant="ghost"
          :aria-label="item.data_ga_name"
          :href="item.link_url"
          :data-ga-name="item.data_ga_name"
          :data-ga-location="item.data_ga_location"
        >
          <SlpTypography class="slp-flex" tag="span" variant="body2-bold">
            {{ item.link_text }}
            <SlpIcon
              class="learn-more__icon"
              name="chevron-lg-right"
              variant="product"
            />
          </SlpTypography>
        </SlpButton>
      </SlpColumn>
      <SlpColumn v-if="isActive" :cols="6">
        <div
          class="solutions-item__media"
          :data-aos="animationType"
          data-aos-duration="500"
          data-aos-easing="ease-in-out"
        >
          <nuxt-img
            class="solutions-item__media__image"
            :src="item.image"
            :alt="item.alt"
            loading="lazy"
          />
        </div>
        <SlpButton
          v-if="isMobile"
          class="slp-mt-32 learn-more"
          variant="ghost"
          :aria-label="item.data_ga_name"
          :href="item.link_url"
          :data-ga-name="item.data_ga_name"
          :data-ga-location="item.data_ga_location"
        >
          <SlpTypography tag="span" variant="body2-bold">
            {{ item.link_text }}
            <SlpIcon
              class="learn-more__icon"
              name="chevron-lg-right"
              variant="product"
            />
          </SlpTypography>
        </SlpButton>
      </SlpColumn>
    </SlpRow>
  </section>
</template>

<style scoped lang="scss">
.solutions-item {
  width: 100%;
  transition: all 0.3s ease-in-out;

  &__media {
    max-width: 100%;
    display: flex;
    align-items: center;
    position: sticky;
    top: 160px;

    &__image {
      max-width: 100%;
    }

    @media (min-width: $breakpoint-md) {
      height: 368px;
      &:before {
        content: '';
        background: $color-surface-800;
        position: absolute;
        top: 0;
        height: 100%;
        transform: translateX(5%);
      }
    }
  }

  &__mobile {
    background: $color-surface-50;
    box-shadow: 0px 24px 50px -16px $color-surface-300;
    width: 320px;
    padding: $spacing-16;
    margin-right: $spacing-16;
    min-height: 585px;
  }

  &--inactive {
    opacity: 0.6;
  }

  &__icon {
    width: 24px;
    height: 24px;
  }

  .learn-more {
    color: $color-text-300;
    padding-left: 0;
    font-size: 18px;
    text-decoration: underline;
    text-underline-offset: 2px;
    text-decoration-color: transparent;
    transition: all 0.3s ease-in-out;

    &__icon {
      margin-left: $spacing-4;
      padding-top: 2px;
      vertical-align: middle;
      transition: transform 0.3s ease-in-out;
    }

    &:hover,
    &:active {
      text-decoration-color: $color-text-300;

      .learn-more__icon {
        transform: translateX($spacing-8);
      }
    }
  }
}
</style>
